       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLSUBC2.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      * MAINTENANCE
      * -----------
      * 1994/02/27 Simmons, Created program.
      *
      *****************************************************************
      * Source Member: CBLSUBC1.CBL
      * Copy Files:    none...
      * Calls to:      none...
      *****************************************************************
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     JCLINPUT SEQUENTIAL    FIXED      00080            *
      *  OUTPUT    SUBTORDR SEQUENTIAL    FIXED      00080            *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT JCLINPUT-FILE  ASSIGN TO       JCLINPUT
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS JCLINPUT-STATUS.
           SELECT SUBTORDR-FILE  ASSIGN TO       SUBTORDR
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS SUBTORDR-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  JCLINPUT-FILE
           DATA RECORD    IS JCLINPUT-REC
           .
       01  JCLINPUT-REC.
           05  JCLINPUT-DATA-01 PIC X(00080).

       FD  SUBTORDR-FILE
           DATA RECORD    IS SUBTORDR-REC
           .
       01  SUBTORDR-REC.
           05  SUBTORDR-DATA-01 PIC X(00080).

      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLSUBC2 '.
           05  T2 pic X(34) value 'A COBOL Program, Submit to INTRDR '.
           05  T3 pic X(10) value ' v08.06.05'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLSUBC2 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  JCLINPUT-STATUS.
           05  JCLINPUT-STATUS-L     pic X.
           05  JCLINPUT-STATUS-R     pic X.
       01  JCLINPUT-EOF              pic X       value 'N'.
       01  JCLINPUT-OPEN-FLAG        pic X       value 'C'.

       01  SUBTORDR-STATUS.
           05  SUBTORDR-STATUS-L     pic X.
           05  SUBTORDR-STATUS-R     pic X.
       01  SUBTORDR-EOF              pic X       value 'N'.
       01  SUBTORDR-OPEN-FLAG        pic X       value 'C'.

       01  JCLINPUT-LRECL    pic 9(5)    value 00080.
       01  SUBTORDR-LRECL    pic 9(5)    value 00080.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLSUBC2 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(109)  value SPACES.
               10  MESSAGE-TEXT-2  pic X(136)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)     value 'CBLSUBC1'.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  CHANGE-JOB-CLASS        pic X        value 'Y'.
       01  CLASS-SEARCH            pic X(7)     value SPACES.
       01  CLASS-MODIFY            pic X(7)     value SPACES.

       01  JCLINPUT-TOTAL.
           05  JCLINPUT-RDR  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for JCLINPUT'.
       01  SUBTORDR-TOTAL.
           05  SUBTORDR-ADD  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for SUBTORDR'.

       01  MESSAGE-TEXT-01.
           05  filler   pic X(20)  value 'Parameter length is '.
           05  JCL-PARM-LENGTH     pic 9(5)    value 0.

      *****************************************************************
       LINKAGE SECTION.
       01  PARM-BUFFER.
           05  PARM-LENGTH         pic S9(4)   comp.
           05  PARM-DATA           pic X(256).

      *****************************************************************
       PROCEDURE DIVISION using PARM-BUFFER.
           perform Z-POST-COPYRIGHT
           perform EXTERNAL-PARAMETERS

           perform JCLINPUT-OPEN
           perform SUBTORDR-OPEN

           perform until JCLINPUT-STATUS not = '00'
               perform JCLINPUT-READ
               if  JCLINPUT-STATUS = '00'
                   add 1 to JCLINPUT-RDR
                   perform BUILD-OUTPUT-RECORD
      *            Display JCL Statement to SYSOUT
                   move SUBTORDR-REC to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
      *            Submit JCL Statement to INTRDR
                   perform SUBTORDR-WRITE
                   if  SUBTORDR-STATUS = '00'
                       add 1 to SUBTORDR-ADD
                   end-if
               end-if
           end-perform

           move JCLINPUT-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move SUBTORDR-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           perform SUBTORDR-CLOSE
           perform JCLINPUT-CLOSE
           GOBACK.

      *****************************************************************
       BUILD-OUTPUT-RECORD.
      *>   TransCOPY...
           move JCLINPUT-REC to SUBTORDR-REC
           if  CHANGE-JOB-CLASS = 'Y'
           and SUBTORDR-REC(1:3) not = '//*'
               inspect SUBTORDR-REC
               replacing first 'CLASS=1' by 'CLASS=R'
               if  JCLINPUT-REC not = SUBTORDR-REC
                   move 'N' to CHANGE-JOB-CLASS
               end-if
           end-if
           exit.

      *****************************************************************
       EXTERNAL-PARAMETERS.
           add PARM-LENGTH to ZERO giving JCL-PARM-LENGTH
           move MESSAGE-TEXT-01 to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  PARM-LENGTH > 0
               move PARM-DATA(1:PARM-LENGTH) to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if

      *          ....:....1....:....2....:
      *    PARM='CHANGE CLASS=1 TO CLASS=R
           if  PARM-LENGTH = 25
           and PARM-DATA(1:7) = 'CHANGE '
           and PARM-DATA(15:4) = ' TO '
               move PARM-DATA(8:7)  to CLASS-SEARCH
               move PARM-DATA(19:7) to CLASS-MODIFY
               move 'External PARM accepted...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move 'N' to CHANGE-JOB-CLASS
               move 'External PARM is invalid, parameter ignored!'
                 to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if

           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       JCLINPUT-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close JCLINPUT-FILE
           if  JCLINPUT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with JCLINPUT' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move JCLINPUT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       JCLINPUT-READ.
           read JCLINPUT-FILE
           if  JCLINPUT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  JCLINPUT-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to JCLINPUT-EOF
               else
                   move 'READ Failure with JCLINPUT' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move JCLINPUT-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       JCLINPUT-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input JCLINPUT-FILE
           if  JCLINPUT-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to JCLINPUT-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with JCLINPUT' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move JCLINPUT-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       SUBTORDR-WRITE.
           if  SUBTORDR-OPEN-FLAG = 'C'
               perform SUBTORDR-OPEN
           end-if
           write SUBTORDR-REC
           if  SUBTORDR-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  SUBTORDR-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with SUBTORDR' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move SUBTORDR-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SUBTORDR-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT SUBTORDR-FILE
           if  SUBTORDR-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to SUBTORDR-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with SUBTORDR' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move SUBTORDR-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SUBTORDR-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close SUBTORDR-FILE
           if  SUBTORDR-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to SUBTORDR-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with SUBTORDR' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move SUBTORDR-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:120)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2008-04-28  Generation Time: 18:02:52:62    *
      *****************************************************************
