//UVDD01J2 JOB SIMOTIME,ACCOUNT,CLASS=1,MSGCLASS=0,NOTIFY=&SYSUID
//* *******************************************************************
//*       UVDD01J2.JCL - a JCL Member for Batch Job Processing        *
//*       This JCL Member is provided by SimoTime Technologies        *
//*           (C) Copyright 1987-2019 All Rights Reserved             *
//*             Web Site URL:   http://www.simotime.com               *
//*                   e-mail:   helpdesk@simotime.com                 *
//* *******************************************************************
//*
//* Text   - Sort a File, create a new sorted file.
//* Author - SimoTime Technologies
//* Date   - January 24, 1996
//*
//* The first job step (PREPARE) will delete a previously created
//* file. The second job step (SORTFILE) will sort records from an
//* input file and create a new file. The sorting specifications are
//* obtained from a PDS Member in a PDS.
//*
//* Note: the input file to be sorted is created by UVDD01J1.JCL
//*
//* This set of programs will run on a mainframe under MVS or on a
//* Personal Computer with Windows and Micro Focus Server.
//*
//* *******************************************************************
//* Step 1 of 2, Delete previously created files...
//*
//JOBSETUP EXEC PGM=IEFBR14
//SYSUT2   DD  DSN=SIMOTIME.DATA.UVFILES1,DISP=(MOD,DELETE,DELETE),
//             STORCLAS=MFI,
//             SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,DSORG=PS)
//*
//* *******************************************************************
//* Step 2 of 2, Sort the file...
//*
//SORTFILE EXEC PGM=SORT,COND=(0,LT),
//             REGION=1024K
//SYSIN    DD  DSN=SIMOTIME.PDS.PARMLIB(UVDD01T1),DISP=SHR
//SORTIN   DD  DSN=SIMOTIME.DATA.UVFILE01,DISP=OLD
//SORTWK01 DD  UNIT=SYSDA,SPACE=(CYL,55)
//SORTWK02 DD  UNIT=SYSDA,SPACE=(CYL,55)
//SORTWK03 DD  UNIT=SYSDA,SPACE=(CYL,55)
//SORTOUT  DD  DSN=SIMOTIME.DATA.UVFILES1,DISP=(NEW,CATLG,DELETE),
//             STORCLAS=MFI,SPACE=(TRK,5),
//             DCB=(RECFM=FB,LRECL=80,DSORG=PS)
//SYSOUT   DD  SYSOUT=*
//*
